/******************************************************************************
*
* project name:    Scorch
* file name:       functions##.h
* initial date:    27.12.2004
* author:          mhubi@freesurf.ch
* description:     declaration of all functions
*
*******************************************************************************
*
* Scorch -- another tank-game
* Copyright (C) 2004-2005  Martin Huber
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/


// declaration of functions
// Main##.c
void _main(void);
void Intro(void);
void Welcome(void);
void GameLoop(void);
void PlayRound(void);
void Extro(void);
void Delay(unsigned int);
void LeadOut(int);
void MainMenu(void);
void MemoryAllocation(void);
//void Memory(void);
short IsVTI(void);
void VTIPoking(void);
void Debugging(unsigned int);

// Input##.c
int KeyPressed(void);
void Waitkey(void);
void Wait(void);
void Inputstr(char *, unsigned short);

// Gamefunc##.c
void Landscape(unsigned int);
void DrawScreen(void);
void InitRound(void);
void Tankset(unsigned int);
void DrawTank(unsigned int, unsigned int);
void MaskTank(unsigned int);
void Tube(unsigned int);
void MainShot(unsigned int, TARGET *);
BOOL ShotEngine(int, int, int, int, unsigned int, TARGET *);
int CheckImpact(int, int, int, int, TARGET *);
void NormalBomb(unsigned int, unsigned int, unsigned int);
void ClipCircle(int, int, int, int, unsigned int);
void CirclePixel(int, int, int);
void Napalm(int, unsigned int);
void Laser(int, int, int, unsigned int);
void MultiBomb(unsigned int, unsigned int, unsigned int, unsigned int);
void MultiBombLaser(int, int, TARGET *, BOOL);
void Explosion(unsigned int, unsigned int, unsigned int, BOOL);
void EarthControl(int, int);
void CheckLife(BOOL);
void HealthControl(unsigned int, int, int, BOOL);
void CalcHealth(unsigned int, int, BOOL);
void TankFall(BOOL);
void Inventory(unsigned int);
void MassKill(void);
void ChangingWind(void);
void SetStartValues(void);
void InitClouds(void);
void DrawClouds(void);
void SpecialEvent(void);
void LittleFlash(int, int, int);
void MainFlash(void);
void Earthquake(int, int, unsigned int, BOOL);
//void Background(void);

// Extern##.c
unsigned char *GetDataPtr(const char *, short);
void Archive(const char *);
void Unarchive(const char *);
void SaveGame(void);
void LoadGame(void);
void DecompRLEVert(unsigned char *, unsigned char *, int, int, int);
void LoadOptions(BOOL);
void SaveOptions(void);
unsigned int OptionsRequest(void);

// Gui##.c
void P_R_choose(void);
void PlayerSettings(void);
void Player_init(unsigned int);
void DrawSettings(void);
void GameSettings(void);
void Statistics(void);
BOOL CheckStat(unsigned int, unsigned int, unsigned int *);
void WeaponList(unsigned int, unsigned int, unsigned int);
void WeaponStatusLine(unsigned int, unsigned int);
int WeaponCursor(int, unsigned int);
void Shop(unsigned int);
void Init_background(void);
void Rectangle(void);
void Tankchose(unsigned int);
void Dispinf(unsigned int);
void Angle(unsigned int, int);
void Power(int *, int);
void DeleteMenuEntry(unsigned int);
void DrawDoubleCursor(unsigned int);
int MakeChoice(unsigned int, unsigned int, unsigned int, int, unsigned int, int);
void DialogStatusLine(unsigned int);

// pixcollide8.s
short PixCollide8(register short x0 asm("%d1"),
									register short y0 asm("%d0"), 
									register short x1 asm("%d2"), 
									register short y1 asm("%d3"), 
									register short height asm("%d4"), 
									register unsigned char* data1 asm("%a0"))__attribute__((__regparm__(6)));

// Ai##.c
void AiMain(TARGET *, unsigned int);
void ChooseEnnemi(unsigned int, int);
void AiShop(void);
unsigned int BuildItemList(unsigned int *, unsigned int);
void ChooseWeapon(unsigned int);
void ChooseArmor(unsigned int);
void ChooseAngle(unsigned int, unsigned int);
BOOL CheckHuman(void);
void ForceChooseEnnemi(unsigned int);
//void Aidata(void);

